library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_unsigned.all;
use ieee.numeric_std.all;

LIBRARY altera_mf;
USE altera_mf.all;

entity xillydemo is
  port (
    GPIO_LED : OUT std_logic_vector(3 DOWNTO 0);
    clk_bot1 : IN std_logic;
    
    hps_0_hps_io_hps_io_emac1_inst_RXD0 : IN std_logic;
    hps_0_hps_io_hps_io_emac1_inst_RXD1 : IN std_logic;
    hps_0_hps_io_hps_io_emac1_inst_RXD2 : IN std_logic;
    hps_0_hps_io_hps_io_emac1_inst_RXD3 : IN std_logic;
    hps_0_hps_io_hps_io_emac1_inst_RX_CLK : IN std_logic;
    hps_0_hps_io_hps_io_emac1_inst_RX_CTL : IN std_logic;
    hps_0_hps_io_hps_io_spim0_inst_MISO : IN std_logic;
    hps_0_hps_io_hps_io_spim1_inst_MISO : IN std_logic;
    hps_0_hps_io_hps_io_uart0_inst_RX : IN std_logic;
    hps_0_hps_io_hps_io_usb1_inst_CLK : IN std_logic;
    hps_0_hps_io_hps_io_usb1_inst_DIR : IN std_logic;
    hps_0_hps_io_hps_io_usb1_inst_NXT : IN std_logic;
    hps_0_hps_io_hps_io_emac1_inst_MDIO : INOUT std_logic;
    hps_0_hps_io_hps_io_gpio_inst_GPIO00 : INOUT std_logic;
    hps_0_hps_io_hps_io_gpio_inst_GPIO09 : INOUT std_logic;
    hps_0_hps_io_hps_io_gpio_inst_GPIO35 : INOUT std_logic;
    hps_0_hps_io_hps_io_gpio_inst_GPIO48 : INOUT std_logic;
    hps_0_hps_io_hps_io_gpio_inst_GPIO53 : INOUT std_logic;
    hps_0_hps_io_hps_io_gpio_inst_GPIO54 : INOUT std_logic;
    hps_0_hps_io_hps_io_gpio_inst_GPIO55 : INOUT std_logic;
    hps_0_hps_io_hps_io_gpio_inst_GPIO56 : INOUT std_logic;
    hps_0_hps_io_hps_io_gpio_inst_GPIO61 : INOUT std_logic;
    hps_0_hps_io_hps_io_gpio_inst_GPIO62 : INOUT std_logic;
    hps_0_hps_io_hps_io_i2c1_inst_SCL : INOUT std_logic;
    hps_0_hps_io_hps_io_i2c1_inst_SDA : INOUT std_logic;
    hps_0_hps_io_hps_io_qspi_inst_IO0 : INOUT std_logic;
    hps_0_hps_io_hps_io_qspi_inst_IO1 : INOUT std_logic;
    hps_0_hps_io_hps_io_qspi_inst_IO2 : INOUT std_logic;
    hps_0_hps_io_hps_io_qspi_inst_IO3 : INOUT std_logic;
    hps_0_hps_io_hps_io_sdio_inst_CMD : INOUT std_logic;
    hps_0_hps_io_hps_io_sdio_inst_D0 : INOUT std_logic;
    hps_0_hps_io_hps_io_sdio_inst_D1 : INOUT std_logic;
    hps_0_hps_io_hps_io_sdio_inst_D2 : INOUT std_logic;
    hps_0_hps_io_hps_io_sdio_inst_D3 : INOUT std_logic;
    hps_0_hps_io_hps_io_usb1_inst_D0 : INOUT std_logic;
    hps_0_hps_io_hps_io_usb1_inst_D1 : INOUT std_logic;
    hps_0_hps_io_hps_io_usb1_inst_D2 : INOUT std_logic;
    hps_0_hps_io_hps_io_usb1_inst_D3 : INOUT std_logic;
    hps_0_hps_io_hps_io_usb1_inst_D4 : INOUT std_logic;
    hps_0_hps_io_hps_io_usb1_inst_D5 : INOUT std_logic;
    hps_0_hps_io_hps_io_usb1_inst_D6 : INOUT std_logic;
    hps_0_hps_io_hps_io_usb1_inst_D7 : INOUT std_logic;
    hps_0_hps_io_hps_io_emac1_inst_MDC : OUT std_logic;
    hps_0_hps_io_hps_io_emac1_inst_TXD0 : OUT std_logic;
    hps_0_hps_io_hps_io_emac1_inst_TXD1 : OUT std_logic;
    hps_0_hps_io_hps_io_emac1_inst_TXD2 : OUT std_logic;
    hps_0_hps_io_hps_io_emac1_inst_TXD3 : OUT std_logic;
    hps_0_hps_io_hps_io_emac1_inst_TX_CLK : OUT std_logic;
    hps_0_hps_io_hps_io_emac1_inst_TX_CTL : OUT std_logic;
    hps_0_hps_io_hps_io_qspi_inst_CLK : OUT std_logic;
    hps_0_hps_io_hps_io_qspi_inst_SS0 : OUT std_logic;
    hps_0_hps_io_hps_io_sdio_inst_CLK : OUT std_logic;
    hps_0_hps_io_hps_io_spim0_inst_CLK : OUT std_logic;
    hps_0_hps_io_hps_io_spim0_inst_MOSI : OUT std_logic;
    hps_0_hps_io_hps_io_spim0_inst_SS0 : OUT std_logic;
    hps_0_hps_io_hps_io_spim1_inst_CLK : OUT std_logic;
    hps_0_hps_io_hps_io_spim1_inst_MOSI : OUT std_logic;
    hps_0_hps_io_hps_io_spim1_inst_SS0 : OUT std_logic;
    hps_0_hps_io_hps_io_uart0_inst_TX : OUT std_logic;
    hps_0_hps_io_hps_io_usb1_inst_STP : OUT std_logic;
    
    memory_mem_a : OUT std_logic_vector(14 DOWNTO 0);
    memory_mem_ba : OUT std_logic_vector(2 DOWNTO 0);
    memory_mem_cas_n : OUT std_logic;
    memory_mem_ck : OUT std_logic;
    memory_mem_ck_n : OUT std_logic;
    memory_mem_cke : OUT std_logic;
    memory_mem_cs_n : OUT std_logic;
    memory_mem_dm : OUT std_logic_vector(3 DOWNTO 0);
    memory_mem_odt : OUT std_logic;
    memory_mem_ras_n : OUT std_logic;
    memory_mem_reset_n : OUT std_logic;
    memory_mem_we_n : OUT std_logic;
    memory_mem_dq : INOUT std_logic_vector(31 DOWNTO 0);
    memory_mem_dqs : INOUT std_logic_vector(3 DOWNTO 0);
    memory_mem_dqs_n : INOUT std_logic_vector(3 DOWNTO 0);
    memory_oct_rzqin : IN std_logic;
    
    vga_blank_n : OUT std_logic;
    vga_blue : OUT std_logic_vector(7 DOWNTO 0);
    vga_clk_out : OUT std_logic;
    vga_green : OUT std_logic_vector(7 DOWNTO 0);
    vga_hsync : OUT std_logic;
    vga_red : OUT std_logic_vector(7 DOWNTO 0);
    vga_sync_n : OUT std_logic;
    vga_vsync : OUT std_logic);
end xillydemo;

architecture sample_arch of xillydemo is
  component xillybus
    port (
      clk_bot1 : IN std_logic;
      hps_0_hps_io_hps_io_emac1_inst_RXD0 : IN std_logic;
      hps_0_hps_io_hps_io_emac1_inst_RXD1 : IN std_logic;
      hps_0_hps_io_hps_io_emac1_inst_RXD2 : IN std_logic;
      hps_0_hps_io_hps_io_emac1_inst_RXD3 : IN std_logic;
      hps_0_hps_io_hps_io_emac1_inst_RX_CLK : IN std_logic;
      hps_0_hps_io_hps_io_emac1_inst_RX_CTL : IN std_logic;
      hps_0_hps_io_hps_io_spim0_inst_MISO : IN std_logic;
      hps_0_hps_io_hps_io_spim1_inst_MISO : IN std_logic;
      hps_0_hps_io_hps_io_uart0_inst_RX : IN std_logic;
      hps_0_hps_io_hps_io_usb1_inst_CLK : IN std_logic;
      hps_0_hps_io_hps_io_usb1_inst_DIR : IN std_logic;
      hps_0_hps_io_hps_io_usb1_inst_NXT : IN std_logic;
      memory_oct_rzqin : IN std_logic;
      hps_0_hps_io_hps_io_emac1_inst_MDIO : INOUT std_logic;
      hps_0_hps_io_hps_io_gpio_inst_GPIO00 : INOUT std_logic;
      hps_0_hps_io_hps_io_gpio_inst_GPIO09 : INOUT std_logic;
      hps_0_hps_io_hps_io_gpio_inst_GPIO35 : INOUT std_logic;
      hps_0_hps_io_hps_io_gpio_inst_GPIO48 : INOUT std_logic;
      hps_0_hps_io_hps_io_gpio_inst_GPIO53 : INOUT std_logic;
      hps_0_hps_io_hps_io_gpio_inst_GPIO54 : INOUT std_logic;
      hps_0_hps_io_hps_io_gpio_inst_GPIO55 : INOUT std_logic;
      hps_0_hps_io_hps_io_gpio_inst_GPIO56 : INOUT std_logic;
      hps_0_hps_io_hps_io_gpio_inst_GPIO61 : INOUT std_logic;
      hps_0_hps_io_hps_io_gpio_inst_GPIO62 : INOUT std_logic;
      hps_0_hps_io_hps_io_i2c1_inst_SCL : INOUT std_logic;
      hps_0_hps_io_hps_io_i2c1_inst_SDA : INOUT std_logic;
      hps_0_hps_io_hps_io_qspi_inst_IO0 : INOUT std_logic;
      hps_0_hps_io_hps_io_qspi_inst_IO1 : INOUT std_logic;
      hps_0_hps_io_hps_io_qspi_inst_IO2 : INOUT std_logic;
      hps_0_hps_io_hps_io_qspi_inst_IO3 : INOUT std_logic;
      hps_0_hps_io_hps_io_sdio_inst_CMD : INOUT std_logic;
      hps_0_hps_io_hps_io_sdio_inst_D0 : INOUT std_logic;
      hps_0_hps_io_hps_io_sdio_inst_D1 : INOUT std_logic;
      hps_0_hps_io_hps_io_sdio_inst_D2 : INOUT std_logic;
      hps_0_hps_io_hps_io_sdio_inst_D3 : INOUT std_logic;
      hps_0_hps_io_hps_io_usb1_inst_D0 : INOUT std_logic;
      hps_0_hps_io_hps_io_usb1_inst_D1 : INOUT std_logic;
      hps_0_hps_io_hps_io_usb1_inst_D2 : INOUT std_logic;
      hps_0_hps_io_hps_io_usb1_inst_D3 : INOUT std_logic;
      hps_0_hps_io_hps_io_usb1_inst_D4 : INOUT std_logic;
      hps_0_hps_io_hps_io_usb1_inst_D5 : INOUT std_logic;
      hps_0_hps_io_hps_io_usb1_inst_D6 : INOUT std_logic;
      hps_0_hps_io_hps_io_usb1_inst_D7 : INOUT std_logic;
      memory_mem_dq : INOUT std_logic_vector(31 DOWNTO 0);
      memory_mem_dqs : INOUT std_logic_vector(3 DOWNTO 0);
      memory_mem_dqs_n : INOUT std_logic_vector(3 DOWNTO 0);
      GPIO_LED : OUT std_logic_vector(3 DOWNTO 0);
      bus_clk : OUT std_logic;
      hps_0_hps_io_hps_io_emac1_inst_MDC : OUT std_logic;
      hps_0_hps_io_hps_io_emac1_inst_TXD0 : OUT std_logic;
      hps_0_hps_io_hps_io_emac1_inst_TXD1 : OUT std_logic;
      hps_0_hps_io_hps_io_emac1_inst_TXD2 : OUT std_logic;
      hps_0_hps_io_hps_io_emac1_inst_TXD3 : OUT std_logic;
      hps_0_hps_io_hps_io_emac1_inst_TX_CLK : OUT std_logic;
      hps_0_hps_io_hps_io_emac1_inst_TX_CTL : OUT std_logic;
      hps_0_hps_io_hps_io_qspi_inst_CLK : OUT std_logic;
      hps_0_hps_io_hps_io_qspi_inst_SS0 : OUT std_logic;
      hps_0_hps_io_hps_io_sdio_inst_CLK : OUT std_logic;
      hps_0_hps_io_hps_io_spim0_inst_CLK : OUT std_logic;
      hps_0_hps_io_hps_io_spim0_inst_MOSI : OUT std_logic;
      hps_0_hps_io_hps_io_spim0_inst_SS0 : OUT std_logic;
      hps_0_hps_io_hps_io_spim1_inst_CLK : OUT std_logic;
      hps_0_hps_io_hps_io_spim1_inst_MOSI : OUT std_logic;
      hps_0_hps_io_hps_io_spim1_inst_SS0 : OUT std_logic;
      hps_0_hps_io_hps_io_uart0_inst_TX : OUT std_logic;
      hps_0_hps_io_hps_io_usb1_inst_STP : OUT std_logic;
      memory_mem_a : OUT std_logic_vector(14 DOWNTO 0);
      memory_mem_ba : OUT std_logic_vector(2 DOWNTO 0);
      memory_mem_cas_n : OUT std_logic;
      memory_mem_ck : OUT std_logic;
      memory_mem_ck_n : OUT std_logic;
      memory_mem_cke : OUT std_logic;
      memory_mem_cs_n : OUT std_logic;
      memory_mem_dm : OUT std_logic_vector(3 DOWNTO 0);
      memory_mem_odt : OUT std_logic;
      memory_mem_ras_n : OUT std_logic;
      memory_mem_reset_n : OUT std_logic;
      memory_mem_we_n : OUT std_logic;
      quiesce : OUT std_logic;
      vga_blank_n : OUT std_logic;
      vga_blue : OUT std_logic_vector(7 DOWNTO 0);
      vga_clk_out : OUT std_logic;
      vga_green : OUT std_logic_vector(7 DOWNTO 0);
      vga_hsync : OUT std_logic;
      vga_red : OUT std_logic_vector(7 DOWNTO 0);
      vga_sync_n : OUT std_logic;
      vga_vsync : OUT std_logic;
      user_r_mem_8_rden : OUT std_logic;
      user_r_mem_8_empty : IN std_logic;
      user_r_mem_8_data : IN std_logic_vector(7 DOWNTO 0);
      user_r_mem_8_eof : IN std_logic;
      user_r_mem_8_open : OUT std_logic;
      user_w_mem_8_wren : OUT std_logic;
      user_w_mem_8_full : IN std_logic;
      user_w_mem_8_data : OUT std_logic_vector(7 DOWNTO 0);
      user_w_mem_8_open : OUT std_logic;
      user_mem_8_addr : OUT std_logic_vector(4 DOWNTO 0);
      user_mem_8_addr_update : OUT std_logic;
      user_r_read_32_rden : OUT std_logic;
      user_r_read_32_empty : IN std_logic;
      user_r_read_32_data : IN std_logic_vector(31 DOWNTO 0);
      user_r_read_32_eof : IN std_logic;
      user_r_read_32_open : OUT std_logic;
      user_r_read_8_rden : OUT std_logic;
      user_r_read_8_empty : IN std_logic;
      user_r_read_8_data : IN std_logic_vector(7 DOWNTO 0);
      user_r_read_8_eof : IN std_logic;
      user_r_read_8_open : OUT std_logic;
      user_w_write_32_wren : OUT std_logic;
      user_w_write_32_full : IN std_logic;
      user_w_write_32_data : OUT std_logic_vector(31 DOWNTO 0);
      user_w_write_32_open : OUT std_logic;
      user_w_write_8_wren : OUT std_logic;
      user_w_write_8_full : IN std_logic;
      user_w_write_8_data : OUT std_logic_vector(7 DOWNTO 0);
      user_w_write_8_open : OUT std_logic;
      user_clk : OUT std_logic;
      user_wren : OUT std_logic;
      user_wstrb : OUT std_logic_vector(3 DOWNTO 0);
      user_rden : OUT std_logic;
      user_rd_data : IN std_logic_vector(31 DOWNTO 0);
      user_wr_data : OUT std_logic_vector(31 DOWNTO 0);
      user_addr : OUT std_logic_vector(31 DOWNTO 0);
      user_irq : IN std_logic);
end component;

  COMPONENT scfifo
    GENERIC (
      add_ram_output_register	: STRING;
      intended_device_family	: STRING;
      lpm_numwords		: NATURAL;
      lpm_showahead		: STRING;
      lpm_type		        : STRING;
      lpm_width		        : NATURAL;
      lpm_widthu		: NATURAL;
      overflow_checking		: STRING;
      underflow_checking	: STRING;
      use_eab		        : STRING
      );
    PORT (
      clock	: IN STD_LOGIC ;
      data	: IN STD_LOGIC_VECTOR ( (lpm_width - 1) DOWNTO 0);
      rdreq	: IN STD_LOGIC ;
      sclr	: IN STD_LOGIC ;
      empty	: OUT STD_LOGIC ;
      full	: OUT STD_LOGIC ;
      q	: OUT STD_LOGIC_VECTOR ( (lpm_width - 1) DOWNTO 0);
      wrreq	: IN STD_LOGIC 
      );
  END COMPONENT;

  type demo_mem is array(0 TO 31) of std_logic_vector(7 DOWNTO 0);
  signal demoarray : demo_mem;
  signal litearray0 : demo_mem;
  signal litearray1 : demo_mem;
  signal litearray2 : demo_mem;
  signal litearray3 : demo_mem;
  
  signal bus_clk :  std_logic;
  signal quiesce : std_logic;

  signal reset_8 : std_logic;
  signal reset_32 : std_logic;

  signal ram_addr : integer range 0 to 31;
  signal lite_addr : integer range 0 to 31;
  
  signal user_r_mem_8_rden :  std_logic;
  signal user_r_mem_8_empty :  std_logic;
  signal user_r_mem_8_data :  std_logic_vector(7 DOWNTO 0);
  signal user_r_mem_8_eof :  std_logic;
  signal user_r_mem_8_open :  std_logic;
  signal user_w_mem_8_wren :  std_logic;
  signal user_w_mem_8_full :  std_logic;
  signal user_w_mem_8_data :  std_logic_vector(7 DOWNTO 0);
  signal user_w_mem_8_open :  std_logic;
  signal user_mem_8_addr :  std_logic_vector(4 DOWNTO 0);
  signal user_mem_8_addr_update :  std_logic;
  signal user_r_read_32_rden :  std_logic;
  signal user_r_read_32_empty :  std_logic;
  signal user_r_read_32_data :  std_logic_vector(31 DOWNTO 0);
  signal user_r_read_32_eof :  std_logic;
  signal user_r_read_32_open :  std_logic;
  signal user_r_read_8_rden :  std_logic;
  signal user_r_read_8_empty :  std_logic;
  signal user_r_read_8_data :  std_logic_vector(7 DOWNTO 0);
  signal user_r_read_8_eof :  std_logic;
  signal user_r_read_8_open :  std_logic;
  signal user_w_write_32_wren :  std_logic;
  signal user_w_write_32_full :  std_logic;
  signal user_w_write_32_data :  std_logic_vector(31 DOWNTO 0);
  signal user_w_write_32_open :  std_logic;
  signal user_w_write_8_wren :  std_logic;
  signal user_w_write_8_full :  std_logic;
  signal user_w_write_8_data :  std_logic_vector(7 DOWNTO 0);
  signal user_w_write_8_open :  std_logic;
  signal user_clk :  std_logic;
  signal user_wren :  std_logic;
  signal user_wstrb :  std_logic_vector(3 DOWNTO 0);
  signal user_rden :  std_logic;
  signal user_rd_data :  std_logic_vector(31 DOWNTO 0);
  signal user_wr_data :  std_logic_vector(31 DOWNTO 0);
  signal user_addr :  std_logic_vector(31 DOWNTO 0);
  signal user_irq :  std_logic;

begin  
  xillybus_ins : xillybus
    port map (
      -- Ports related to /dev/xillybus_mem_8
      -- FPGA to CPU signals:
      user_r_mem_8_rden => user_r_mem_8_rden,
      user_r_mem_8_empty => user_r_mem_8_empty,
      user_r_mem_8_data => user_r_mem_8_data,
      user_r_mem_8_eof => user_r_mem_8_eof,
      user_r_mem_8_open => user_r_mem_8_open,
      -- CPU to FPGA signals:
      user_w_mem_8_wren => user_w_mem_8_wren,
      user_w_mem_8_full => user_w_mem_8_full,
      user_w_mem_8_data => user_w_mem_8_data,
      user_w_mem_8_open => user_w_mem_8_open,
      -- Address signals:
      user_mem_8_addr => user_mem_8_addr,
      user_mem_8_addr_update => user_mem_8_addr_update,

      -- Ports related to /dev/xillybus_read_32
      -- FPGA to CPU signals:
      user_r_read_32_rden => user_r_read_32_rden,
      user_r_read_32_empty => user_r_read_32_empty,
      user_r_read_32_data => user_r_read_32_data,
      user_r_read_32_eof => user_r_read_32_eof,
      user_r_read_32_open => user_r_read_32_open,

      -- Ports related to /dev/xillybus_read_8
      -- FPGA to CPU signals:
      user_r_read_8_rden => user_r_read_8_rden,
      user_r_read_8_empty => user_r_read_8_empty,
      user_r_read_8_data => user_r_read_8_data,
      user_r_read_8_eof => user_r_read_8_eof,
      user_r_read_8_open => user_r_read_8_open,

      -- Ports related to /dev/xillybus_write_32
      -- CPU to FPGA signals:
      user_w_write_32_wren => user_w_write_32_wren,
      user_w_write_32_full => user_w_write_32_full,
      user_w_write_32_data => user_w_write_32_data,
      user_w_write_32_open => user_w_write_32_open,

      -- Ports related to /dev/xillybus_write_8
      -- CPU to FPGA signals:
      user_w_write_8_wren => user_w_write_8_wren,
      user_w_write_8_full => user_w_write_8_full,
      user_w_write_8_data => user_w_write_8_data,
      user_w_write_8_open => user_w_write_8_open,

      -- Ports related to Xillybus Lite
      user_clk => user_clk,
      user_wren => user_wren,
      user_wstrb => user_wstrb,
      user_rden => user_rden,
      user_rd_data => user_rd_data,
      user_wr_data => user_wr_data,
      user_addr => user_addr,
      user_irq => user_irq,

      -- General signals
      clk_bot1 => clk_bot1,
      hps_0_hps_io_hps_io_emac1_inst_RXD0 => hps_0_hps_io_hps_io_emac1_inst_RXD0,
      hps_0_hps_io_hps_io_emac1_inst_RXD1 => hps_0_hps_io_hps_io_emac1_inst_RXD1,
      hps_0_hps_io_hps_io_emac1_inst_RXD2 => hps_0_hps_io_hps_io_emac1_inst_RXD2,
      hps_0_hps_io_hps_io_emac1_inst_RXD3 => hps_0_hps_io_hps_io_emac1_inst_RXD3,
      hps_0_hps_io_hps_io_emac1_inst_RX_CLK => hps_0_hps_io_hps_io_emac1_inst_RX_CLK,
      hps_0_hps_io_hps_io_emac1_inst_RX_CTL => hps_0_hps_io_hps_io_emac1_inst_RX_CTL,
      hps_0_hps_io_hps_io_spim0_inst_MISO => hps_0_hps_io_hps_io_spim0_inst_MISO,
      hps_0_hps_io_hps_io_spim1_inst_MISO => hps_0_hps_io_hps_io_spim1_inst_MISO,
      hps_0_hps_io_hps_io_uart0_inst_RX => hps_0_hps_io_hps_io_uart0_inst_RX,
      hps_0_hps_io_hps_io_usb1_inst_CLK => hps_0_hps_io_hps_io_usb1_inst_CLK,
      hps_0_hps_io_hps_io_usb1_inst_DIR => hps_0_hps_io_hps_io_usb1_inst_DIR,
      hps_0_hps_io_hps_io_usb1_inst_NXT => hps_0_hps_io_hps_io_usb1_inst_NXT,
      memory_oct_rzqin => memory_oct_rzqin,
      hps_0_hps_io_hps_io_emac1_inst_MDIO => hps_0_hps_io_hps_io_emac1_inst_MDIO,
      hps_0_hps_io_hps_io_gpio_inst_GPIO00 => hps_0_hps_io_hps_io_gpio_inst_GPIO00,
      hps_0_hps_io_hps_io_gpio_inst_GPIO09 => hps_0_hps_io_hps_io_gpio_inst_GPIO09,
      hps_0_hps_io_hps_io_gpio_inst_GPIO35 => hps_0_hps_io_hps_io_gpio_inst_GPIO35,
      hps_0_hps_io_hps_io_gpio_inst_GPIO48 => hps_0_hps_io_hps_io_gpio_inst_GPIO48,
      hps_0_hps_io_hps_io_gpio_inst_GPIO53 => hps_0_hps_io_hps_io_gpio_inst_GPIO53,
      hps_0_hps_io_hps_io_gpio_inst_GPIO54 => hps_0_hps_io_hps_io_gpio_inst_GPIO54,
      hps_0_hps_io_hps_io_gpio_inst_GPIO55 => hps_0_hps_io_hps_io_gpio_inst_GPIO55,
      hps_0_hps_io_hps_io_gpio_inst_GPIO56 => hps_0_hps_io_hps_io_gpio_inst_GPIO56,
      hps_0_hps_io_hps_io_gpio_inst_GPIO61 => hps_0_hps_io_hps_io_gpio_inst_GPIO61,
      hps_0_hps_io_hps_io_gpio_inst_GPIO62 => hps_0_hps_io_hps_io_gpio_inst_GPIO62,
      hps_0_hps_io_hps_io_i2c1_inst_SCL => hps_0_hps_io_hps_io_i2c1_inst_SCL,
      hps_0_hps_io_hps_io_i2c1_inst_SDA => hps_0_hps_io_hps_io_i2c1_inst_SDA,
      hps_0_hps_io_hps_io_qspi_inst_IO0 => hps_0_hps_io_hps_io_qspi_inst_IO0,
      hps_0_hps_io_hps_io_qspi_inst_IO1 => hps_0_hps_io_hps_io_qspi_inst_IO1,
      hps_0_hps_io_hps_io_qspi_inst_IO2 => hps_0_hps_io_hps_io_qspi_inst_IO2,
      hps_0_hps_io_hps_io_qspi_inst_IO3 => hps_0_hps_io_hps_io_qspi_inst_IO3,
      hps_0_hps_io_hps_io_sdio_inst_CMD => hps_0_hps_io_hps_io_sdio_inst_CMD,
      hps_0_hps_io_hps_io_sdio_inst_D0 => hps_0_hps_io_hps_io_sdio_inst_D0,
      hps_0_hps_io_hps_io_sdio_inst_D1 => hps_0_hps_io_hps_io_sdio_inst_D1,
      hps_0_hps_io_hps_io_sdio_inst_D2 => hps_0_hps_io_hps_io_sdio_inst_D2,
      hps_0_hps_io_hps_io_sdio_inst_D3 => hps_0_hps_io_hps_io_sdio_inst_D3,
      hps_0_hps_io_hps_io_usb1_inst_D0 => hps_0_hps_io_hps_io_usb1_inst_D0,
      hps_0_hps_io_hps_io_usb1_inst_D1 => hps_0_hps_io_hps_io_usb1_inst_D1,
      hps_0_hps_io_hps_io_usb1_inst_D2 => hps_0_hps_io_hps_io_usb1_inst_D2,
      hps_0_hps_io_hps_io_usb1_inst_D3 => hps_0_hps_io_hps_io_usb1_inst_D3,
      hps_0_hps_io_hps_io_usb1_inst_D4 => hps_0_hps_io_hps_io_usb1_inst_D4,
      hps_0_hps_io_hps_io_usb1_inst_D5 => hps_0_hps_io_hps_io_usb1_inst_D5,
      hps_0_hps_io_hps_io_usb1_inst_D6 => hps_0_hps_io_hps_io_usb1_inst_D6,
      hps_0_hps_io_hps_io_usb1_inst_D7 => hps_0_hps_io_hps_io_usb1_inst_D7,
      memory_mem_dq => memory_mem_dq,
      memory_mem_dqs => memory_mem_dqs,
      memory_mem_dqs_n => memory_mem_dqs_n,
      GPIO_LED => GPIO_LED,
      bus_clk => bus_clk,
      hps_0_hps_io_hps_io_emac1_inst_MDC => hps_0_hps_io_hps_io_emac1_inst_MDC,
      hps_0_hps_io_hps_io_emac1_inst_TXD0 => hps_0_hps_io_hps_io_emac1_inst_TXD0,
      hps_0_hps_io_hps_io_emac1_inst_TXD1 => hps_0_hps_io_hps_io_emac1_inst_TXD1,
      hps_0_hps_io_hps_io_emac1_inst_TXD2 => hps_0_hps_io_hps_io_emac1_inst_TXD2,
      hps_0_hps_io_hps_io_emac1_inst_TXD3 => hps_0_hps_io_hps_io_emac1_inst_TXD3,
      hps_0_hps_io_hps_io_emac1_inst_TX_CLK => hps_0_hps_io_hps_io_emac1_inst_TX_CLK,
      hps_0_hps_io_hps_io_emac1_inst_TX_CTL => hps_0_hps_io_hps_io_emac1_inst_TX_CTL,
      hps_0_hps_io_hps_io_qspi_inst_CLK => hps_0_hps_io_hps_io_qspi_inst_CLK,
      hps_0_hps_io_hps_io_qspi_inst_SS0 => hps_0_hps_io_hps_io_qspi_inst_SS0,
      hps_0_hps_io_hps_io_sdio_inst_CLK => hps_0_hps_io_hps_io_sdio_inst_CLK,
      hps_0_hps_io_hps_io_spim0_inst_CLK => hps_0_hps_io_hps_io_spim0_inst_CLK,
      hps_0_hps_io_hps_io_spim0_inst_MOSI => hps_0_hps_io_hps_io_spim0_inst_MOSI,
      hps_0_hps_io_hps_io_spim0_inst_SS0 => hps_0_hps_io_hps_io_spim0_inst_SS0,
      hps_0_hps_io_hps_io_spim1_inst_CLK => hps_0_hps_io_hps_io_spim1_inst_CLK,
      hps_0_hps_io_hps_io_spim1_inst_MOSI => hps_0_hps_io_hps_io_spim1_inst_MOSI,
      hps_0_hps_io_hps_io_spim1_inst_SS0 => hps_0_hps_io_hps_io_spim1_inst_SS0,
      hps_0_hps_io_hps_io_uart0_inst_TX => hps_0_hps_io_hps_io_uart0_inst_TX,
      hps_0_hps_io_hps_io_usb1_inst_STP => hps_0_hps_io_hps_io_usb1_inst_STP,
      memory_mem_a => memory_mem_a,
      memory_mem_ba => memory_mem_ba,
      memory_mem_cas_n => memory_mem_cas_n,
      memory_mem_ck => memory_mem_ck,
      memory_mem_ck_n => memory_mem_ck_n,
      memory_mem_cke => memory_mem_cke,
      memory_mem_cs_n => memory_mem_cs_n,
      memory_mem_dm => memory_mem_dm,
      memory_mem_odt => memory_mem_odt,
      memory_mem_ras_n => memory_mem_ras_n,
      memory_mem_reset_n => memory_mem_reset_n,
      memory_mem_we_n => memory_mem_we_n,
      quiesce => quiesce,
      vga_blank_n => vga_blank_n,
      vga_blue => vga_blue,
      vga_clk_out => vga_clk_out,
      vga_green => vga_green,
      vga_hsync => vga_hsync,
      vga_red => vga_red,
      vga_sync_n => vga_sync_n,
      vga_vsync => vga_vsync
  );

  -- Xillybus Lite
  
  user_irq <= '0'; -- No interrupts for now

  lite_addr <= conv_integer(user_addr(6 DOWNTO 2));

  process (user_clk)
  begin
    if (user_clk'event and user_clk = '1') then
      if (user_wstrb(0) = '1') then 
        litearray0(lite_addr) <= user_wr_data(7 DOWNTO 0);
      end if;

      if (user_wstrb(1) = '1') then 
        litearray1(lite_addr) <= user_wr_data(15 DOWNTO 8);
      end if;

      if (user_wstrb(2) = '1') then 
        litearray2(lite_addr) <= user_wr_data(23 DOWNTO 16);
      end if;

      if (user_wstrb(3) = '1') then 
        litearray3(lite_addr) <= user_wr_data(31 DOWNTO 24);
      end if;

      if (user_rden = '1') then
        user_rd_data <= litearray3(lite_addr) & litearray2(lite_addr) &
                        litearray1(lite_addr) & litearray0(lite_addr);
      end if;
    end if;
  end process;
        
--  A simple inferred RAM

  ram_addr <= conv_integer(user_mem_8_addr);
  
  process (bus_clk)
  begin
    if (bus_clk'event and bus_clk = '1') then
      if (user_w_mem_8_wren = '1') then 
        demoarray(ram_addr) <= user_w_mem_8_data;
      end if;
      if (user_r_mem_8_rden = '1') then
        user_r_mem_8_data <= demoarray(ram_addr);
      end if;
    end if;
  end process;

  user_r_mem_8_empty <= '0';
  user_r_mem_8_eof <= '0';
  user_w_mem_8_full <= '0';

--  32-bit loopback
  
  fifo_32 : scfifo
    GENERIC MAP (
      add_ram_output_register => "OFF",
      intended_device_family => "Stratix IV",
      lpm_numwords => 512,
      lpm_showahead => "OFF",
      lpm_type => "scfifo",
      lpm_width => 32,
      lpm_widthu => 9,
      overflow_checking => "ON",
      underflow_checking => "ON",
      use_eab => "ON"
      )
    PORT MAP (
      clock => bus_clk,
      data => user_w_write_32_data,
      rdreq => user_r_read_32_rden,
      sclr => reset_32,
      wrreq => user_w_write_32_wren,
      empty => user_r_read_32_empty,
      full => user_w_write_32_full,
      q => user_r_read_32_data
    );  
  
    reset_32 <= not (user_w_write_32_open or user_r_read_32_open);

    user_r_read_32_eof <= '0';
  
--  8-bit loopback

  fifo_8 : scfifo
    GENERIC MAP (
      add_ram_output_register => "OFF",
      intended_device_family => "Stratix IV",
      lpm_numwords => 2048,
      lpm_showahead => "OFF",
      lpm_type => "scfifo",
      lpm_width => 8,
      lpm_widthu => 11,
      overflow_checking => "ON",
      underflow_checking => "ON",
      use_eab => "ON"
      )
    PORT MAP (
      clock => bus_clk,
      data => user_w_write_8_data,
      rdreq => user_r_read_8_rden,
      sclr => reset_8,
      wrreq => user_w_write_8_wren,
      empty => user_r_read_8_empty,
      full => user_w_write_8_full,
      q => user_r_read_8_data
    );  
  
    reset_8 <= not (user_w_write_8_open or user_r_read_8_open);

    user_r_read_8_eof <= '0';
  
end sample_arch;
