// altera message_off 10230 10335
`timescale 1ns / 10ps

module xillybus(GPIO_LED, quiesce, clk_bot1, memory_mem_a, memory_mem_ba,
  memory_mem_ck, memory_mem_ck_n, memory_mem_cke, memory_mem_cs_n,
  memory_mem_ras_n, memory_mem_cas_n, memory_mem_we_n, memory_mem_reset_n,
  memory_mem_dq, memory_mem_dqs, memory_mem_dqs_n, memory_mem_odt,
  memory_mem_dm, memory_oct_rzqin, hps_0_hps_io_hps_io_emac1_inst_TX_CLK,
  hps_0_hps_io_hps_io_emac1_inst_TXD0, hps_0_hps_io_hps_io_emac1_inst_TXD1,
  hps_0_hps_io_hps_io_emac1_inst_TXD2, hps_0_hps_io_hps_io_emac1_inst_TXD3,
  hps_0_hps_io_hps_io_emac1_inst_RXD0, hps_0_hps_io_hps_io_emac1_inst_MDIO,
  hps_0_hps_io_hps_io_emac1_inst_MDC, hps_0_hps_io_hps_io_emac1_inst_RX_CTL,
  hps_0_hps_io_hps_io_emac1_inst_TX_CTL, hps_0_hps_io_hps_io_emac1_inst_RX_CLK,
  hps_0_hps_io_hps_io_emac1_inst_RXD1, hps_0_hps_io_hps_io_emac1_inst_RXD2,
  hps_0_hps_io_hps_io_emac1_inst_RXD3, hps_0_hps_io_hps_io_qspi_inst_IO0,
  hps_0_hps_io_hps_io_qspi_inst_IO1, hps_0_hps_io_hps_io_qspi_inst_IO2,
  hps_0_hps_io_hps_io_qspi_inst_IO3, hps_0_hps_io_hps_io_qspi_inst_SS0,
  hps_0_hps_io_hps_io_qspi_inst_CLK, hps_0_hps_io_hps_io_sdio_inst_CMD,
  hps_0_hps_io_hps_io_sdio_inst_D0, hps_0_hps_io_hps_io_sdio_inst_D1,
  hps_0_hps_io_hps_io_sdio_inst_CLK, hps_0_hps_io_hps_io_sdio_inst_D2,
  hps_0_hps_io_hps_io_sdio_inst_D3, hps_0_hps_io_hps_io_usb1_inst_D0,
  hps_0_hps_io_hps_io_usb1_inst_D1, hps_0_hps_io_hps_io_usb1_inst_D2,
  hps_0_hps_io_hps_io_usb1_inst_D3, hps_0_hps_io_hps_io_usb1_inst_D4,
  hps_0_hps_io_hps_io_usb1_inst_D5, hps_0_hps_io_hps_io_usb1_inst_D6,
  hps_0_hps_io_hps_io_usb1_inst_D7, hps_0_hps_io_hps_io_usb1_inst_CLK,
  hps_0_hps_io_hps_io_usb1_inst_STP, hps_0_hps_io_hps_io_usb1_inst_DIR,
  hps_0_hps_io_hps_io_usb1_inst_NXT, hps_0_hps_io_hps_io_spim0_inst_CLK,
  hps_0_hps_io_hps_io_spim0_inst_MOSI, hps_0_hps_io_hps_io_spim0_inst_MISO,
  hps_0_hps_io_hps_io_spim0_inst_SS0, hps_0_hps_io_hps_io_spim1_inst_CLK,
  hps_0_hps_io_hps_io_spim1_inst_MOSI, hps_0_hps_io_hps_io_spim1_inst_MISO,
  hps_0_hps_io_hps_io_spim1_inst_SS0, hps_0_hps_io_hps_io_uart0_inst_RX,
  hps_0_hps_io_hps_io_uart0_inst_TX, hps_0_hps_io_hps_io_i2c1_inst_SDA,
  hps_0_hps_io_hps_io_i2c1_inst_SCL, hps_0_hps_io_hps_io_gpio_inst_GPIO00,
  hps_0_hps_io_hps_io_gpio_inst_GPIO09, hps_0_hps_io_hps_io_gpio_inst_GPIO35,
  hps_0_hps_io_hps_io_gpio_inst_GPIO48, hps_0_hps_io_hps_io_gpio_inst_GPIO53,
  hps_0_hps_io_hps_io_gpio_inst_GPIO54, hps_0_hps_io_hps_io_gpio_inst_GPIO55,
  hps_0_hps_io_hps_io_gpio_inst_GPIO56, hps_0_hps_io_hps_io_gpio_inst_GPIO61,
  hps_0_hps_io_hps_io_gpio_inst_GPIO62, bus_clk, user_clk, user_wren,
  user_wstrb, user_rden, user_rd_data, user_wr_data, user_addr, user_irq,
  vga_red, vga_green, vga_blue, vga_hsync, vga_vsync, vga_blank_n, vga_sync_n,
  vga_clk_out, user_r_read_32_rden, user_r_read_32_data, user_r_read_32_empty,
  user_r_read_32_eof, user_r_read_32_open, user_w_write_32_wren,
  user_w_write_32_data, user_w_write_32_full, user_w_write_32_open,
  user_r_read_8_rden, user_r_read_8_data, user_r_read_8_empty,
  user_r_read_8_eof, user_r_read_8_open, user_w_write_8_wren,
  user_w_write_8_data, user_w_write_8_full, user_w_write_8_open,
  user_r_mem_8_rden, user_r_mem_8_data, user_r_mem_8_empty, user_r_mem_8_eof,
  user_r_mem_8_open, user_w_mem_8_wren, user_w_mem_8_data, user_w_mem_8_full,
  user_w_mem_8_open, user_mem_8_addr, user_mem_8_addr_update);

  input  clk_bot1;
  input  memory_oct_rzqin;
  input  hps_0_hps_io_hps_io_emac1_inst_RXD0;
  input  hps_0_hps_io_hps_io_emac1_inst_RX_CTL;
  input  hps_0_hps_io_hps_io_emac1_inst_RX_CLK;
  input  hps_0_hps_io_hps_io_emac1_inst_RXD1;
  input  hps_0_hps_io_hps_io_emac1_inst_RXD2;
  input  hps_0_hps_io_hps_io_emac1_inst_RXD3;
  input  hps_0_hps_io_hps_io_usb1_inst_CLK;
  input  hps_0_hps_io_hps_io_usb1_inst_DIR;
  input  hps_0_hps_io_hps_io_usb1_inst_NXT;
  input  hps_0_hps_io_hps_io_spim0_inst_MISO;
  input  hps_0_hps_io_hps_io_spim1_inst_MISO;
  input  hps_0_hps_io_hps_io_uart0_inst_RX;
  input [31:0] user_rd_data;
  input  user_irq;
  input [31:0] user_r_read_32_data;
  input  user_r_read_32_empty;
  input  user_r_read_32_eof;
  input  user_w_write_32_full;
  input [7:0] user_r_read_8_data;
  input  user_r_read_8_empty;
  input  user_r_read_8_eof;
  input  user_w_write_8_full;
  input [7:0] user_r_mem_8_data;
  input  user_r_mem_8_empty;
  input  user_r_mem_8_eof;
  input  user_w_mem_8_full;
  output [3:0] GPIO_LED;
  output  quiesce;
  output [14:0] memory_mem_a;
  output [2:0] memory_mem_ba;
  output  memory_mem_ck;
  output  memory_mem_ck_n;
  output  memory_mem_cke;
  output  memory_mem_cs_n;
  output  memory_mem_ras_n;
  output  memory_mem_cas_n;
  output  memory_mem_we_n;
  output  memory_mem_reset_n;
  output  memory_mem_odt;
  output [3:0] memory_mem_dm;
  output  hps_0_hps_io_hps_io_emac1_inst_TX_CLK;
  output  hps_0_hps_io_hps_io_emac1_inst_TXD0;
  output  hps_0_hps_io_hps_io_emac1_inst_TXD1;
  output  hps_0_hps_io_hps_io_emac1_inst_TXD2;
  output  hps_0_hps_io_hps_io_emac1_inst_TXD3;
  output  hps_0_hps_io_hps_io_emac1_inst_MDC;
  output  hps_0_hps_io_hps_io_emac1_inst_TX_CTL;
  output  hps_0_hps_io_hps_io_qspi_inst_SS0;
  output  hps_0_hps_io_hps_io_qspi_inst_CLK;
  output  hps_0_hps_io_hps_io_sdio_inst_CLK;
  output  hps_0_hps_io_hps_io_usb1_inst_STP;
  output  hps_0_hps_io_hps_io_spim0_inst_CLK;
  output  hps_0_hps_io_hps_io_spim0_inst_MOSI;
  output  hps_0_hps_io_hps_io_spim0_inst_SS0;
  output  hps_0_hps_io_hps_io_spim1_inst_CLK;
  output  hps_0_hps_io_hps_io_spim1_inst_MOSI;
  output  hps_0_hps_io_hps_io_spim1_inst_SS0;
  output  hps_0_hps_io_hps_io_uart0_inst_TX;
  output  bus_clk;
  output  user_clk;
  output  user_wren;
  output [3:0] user_wstrb;
  output  user_rden;
  output [31:0] user_wr_data;
  output [31:0] user_addr;
  output [7:0] vga_red;
  output [7:0] vga_green;
  output [7:0] vga_blue;
  output  vga_hsync;
  output  vga_vsync;
  output  vga_blank_n;
  output  vga_sync_n;
  output  vga_clk_out;
  output  user_r_read_32_rden;
  output  user_r_read_32_open;
  output  user_w_write_32_wren;
  output [31:0] user_w_write_32_data;
  output  user_w_write_32_open;
  output  user_r_read_8_rden;
  output  user_r_read_8_open;
  output  user_w_write_8_wren;
  output [7:0] user_w_write_8_data;
  output  user_w_write_8_open;
  output  user_r_mem_8_rden;
  output  user_r_mem_8_open;
  output  user_w_mem_8_wren;
  output [7:0] user_w_mem_8_data;
  output  user_w_mem_8_open;
  output [4:0] user_mem_8_addr;
  output  user_mem_8_addr_update;
  inout [31:0] memory_mem_dq;
  inout [3:0] memory_mem_dqs;
  inout [3:0] memory_mem_dqs_n;
  inout  hps_0_hps_io_hps_io_emac1_inst_MDIO;
  inout  hps_0_hps_io_hps_io_qspi_inst_IO0;
  inout  hps_0_hps_io_hps_io_qspi_inst_IO1;
  inout  hps_0_hps_io_hps_io_qspi_inst_IO2;
  inout  hps_0_hps_io_hps_io_qspi_inst_IO3;
  inout  hps_0_hps_io_hps_io_sdio_inst_CMD;
  inout  hps_0_hps_io_hps_io_sdio_inst_D0;
  inout  hps_0_hps_io_hps_io_sdio_inst_D1;
  inout  hps_0_hps_io_hps_io_sdio_inst_D2;
  inout  hps_0_hps_io_hps_io_sdio_inst_D3;
  inout  hps_0_hps_io_hps_io_usb1_inst_D0;
  inout  hps_0_hps_io_hps_io_usb1_inst_D1;
  inout  hps_0_hps_io_hps_io_usb1_inst_D2;
  inout  hps_0_hps_io_hps_io_usb1_inst_D3;
  inout  hps_0_hps_io_hps_io_usb1_inst_D4;
  inout  hps_0_hps_io_hps_io_usb1_inst_D5;
  inout  hps_0_hps_io_hps_io_usb1_inst_D6;
  inout  hps_0_hps_io_hps_io_usb1_inst_D7;
  inout  hps_0_hps_io_hps_io_i2c1_inst_SDA;
  inout  hps_0_hps_io_hps_io_i2c1_inst_SCL;
  inout  hps_0_hps_io_hps_io_gpio_inst_GPIO00;
  inout  hps_0_hps_io_hps_io_gpio_inst_GPIO09;
  inout  hps_0_hps_io_hps_io_gpio_inst_GPIO35;
  inout  hps_0_hps_io_hps_io_gpio_inst_GPIO48;
  inout  hps_0_hps_io_hps_io_gpio_inst_GPIO53;
  inout  hps_0_hps_io_hps_io_gpio_inst_GPIO54;
  inout  hps_0_hps_io_hps_io_gpio_inst_GPIO55;
  inout  hps_0_hps_io_hps_io_gpio_inst_GPIO56;
  inout  hps_0_hps_io_hps_io_gpio_inst_GPIO61;
  inout  hps_0_hps_io_hps_io_gpio_inst_GPIO62;
  wire  bus_rst_n;
  wire  host_interrupt;
  wire  S_AXI_AWVALID;
  wire [31:0] S_AXI_WDATA;
  wire [3:0] S_AXI_WSTRB;
  wire  S_AXI_WVALID;
  wire  S_AXI_BREADY;
  wire [6:0] S_AXI_ARADDR;
  wire  S_AXI_ARVALID;
  wire  S_AXI_RREADY;
  wire  S_AXI_ARREADY;
  wire [31:0] S_AXI_RDATA;
  wire [1:0] S_AXI_RRESP;
  wire  S_AXI_RVALID;
  wire  S_AXI_WREADY;
  wire [1:0] S_AXI_BRESP;
  wire  S_AXI_BVALID;
  wire  S_AXI_AWREADY;
  wire  M_AXI_ACP_ARREADY;
  wire  M_AXI_ACP_ARVALID;
  wire [31:0] M_AXI_ACP_ARADDR;
  wire [3:0] M_AXI_ACP_ARLEN;
  wire [2:0] M_AXI_ACP_ARSIZE;
  wire [1:0] M_AXI_ACP_ARBURST;
  wire [2:0] M_AXI_ACP_ARPROT;
  wire [3:0] M_AXI_ACP_ARCACHE;
  wire  M_AXI_ACP_RREADY;
  wire  M_AXI_ACP_RVALID;
  wire [63:0] M_AXI_ACP_RDATA;
  wire [1:0] M_AXI_ACP_RRESP;
  wire  M_AXI_ACP_RLAST;
  wire  M_AXI_ACP_AWREADY;
  wire  M_AXI_ACP_AWVALID;
  wire [31:0] M_AXI_ACP_AWADDR;
  wire [3:0] M_AXI_ACP_AWLEN;
  wire [2:0] M_AXI_ACP_AWSIZE;
  wire [1:0] M_AXI_ACP_AWBURST;
  wire [2:0] M_AXI_ACP_AWPROT;
  wire [3:0] M_AXI_ACP_AWCACHE;
  wire  M_AXI_ACP_WREADY;
  wire  M_AXI_ACP_WVALID;
  wire [63:0] M_AXI_ACP_WDATA;
  wire [7:0] M_AXI_ACP_WID;
  wire [7:0] M_AXI_ACP_WSTRB;
  wire  M_AXI_ACP_WLAST;
  wire  M_AXI_ACP_BREADY;
  wire  M_AXI_ACP_BVALID;
  wire [1:0] M_AXI_ACP_BRESP;
  wire [1:0] M_AXI_ACP_AWLOCK;
  wire [1:0] M_AXI_ACP_ARLOCK;
  wire [7:0] M_AXI_ACP_AWID;
  wire [7:0] M_AXI_ACP_BID;
  wire [7:0] M_AXI_ACP_RID;
  wire [7:0] M_AXI_ACP_ARID;
  wire [4:0] M_AXI_ACP_ARUSER;
  wire [4:0] M_AXI_ACP_AWUSER;
  wire [11:0] S_AXI_AWID;
  wire [6:0] S_AXI_AWADDR;
  wire [3:0] S_AXI_AWLEN;
  wire [2:0] S_AXI_AWSIZE;
  wire [1:0] S_AXI_AWBURST;
  wire [1:0] S_AXI_AWLOCK;
  wire [3:0] S_AXI_AWCACHE;
  wire [2:0] S_AXI_AWPROT;
  wire [4:0] S_AXI_AWUSER;
  wire [11:0] S_AXI_WID;
  wire [11:0] S_AXI_BID;
  wire  S_AXI_WLAST;
  wire [11:0] S_AXI_ARID;
  wire [3:0] S_AXI_ARLEN;
  wire [2:0] S_AXI_ARSIZE;
  wire [1:0] S_AXI_ARBURST;
  wire [1:0] S_AXI_ARLOCK;
  wire [3:0] S_AXI_ARCACHE;
  wire [2:0] S_AXI_ARPROT;
  wire [4:0] S_AXI_ARUSER;
  wire [11:0] S_AXI_RID;
  wire  S_AXI_RLAST;
  wire [7:0] vga_red_w;
  wire [7:0] vga_green_w;
  wire [7:0] vga_blue_w;
  wire  vga_hsync_w;
  wire  vga_vsync_w;
  wire  vga_blank_n_w;
  wire  vga_sync_n_w;
  wire  vga_clk;
  wire  hps_0_h2f_reset_reset_n;
  wire  clk_clk;
  wire  locked;

     soc_system u0
       (
	.clk_clk (clk_clk),
	.reset_reset_n (hps_0_h2f_reset_reset_n && locked),
	.memory_mem_a (memory_mem_a),
	.memory_mem_ba (memory_mem_ba),
	.memory_mem_ck (memory_mem_ck),
	.memory_mem_ck_n (memory_mem_ck_n),
	.memory_mem_cke (memory_mem_cke),
	.memory_mem_cs_n (memory_mem_cs_n),
	.memory_mem_ras_n (memory_mem_ras_n),
	.memory_mem_cas_n (memory_mem_cas_n),
	.memory_mem_we_n (memory_mem_we_n),
	.memory_mem_reset_n (memory_mem_reset_n),
	.memory_mem_dq (memory_mem_dq),
	.memory_mem_dqs (memory_mem_dqs),
	.memory_mem_dqs_n (memory_mem_dqs_n),
	.memory_mem_odt (memory_mem_odt),
	.memory_mem_dm (memory_mem_dm),
	.memory_oct_rzqin (memory_oct_rzqin),
	.hps_0_hps_io_hps_io_emac1_inst_TX_CLK (hps_0_hps_io_hps_io_emac1_inst_TX_CLK),
	.hps_0_hps_io_hps_io_emac1_inst_TXD0 (hps_0_hps_io_hps_io_emac1_inst_TXD0),
	.hps_0_hps_io_hps_io_emac1_inst_TXD1 (hps_0_hps_io_hps_io_emac1_inst_TXD1),
	.hps_0_hps_io_hps_io_emac1_inst_TXD2 (hps_0_hps_io_hps_io_emac1_inst_TXD2),
	.hps_0_hps_io_hps_io_emac1_inst_TXD3 (hps_0_hps_io_hps_io_emac1_inst_TXD3),
	.hps_0_hps_io_hps_io_emac1_inst_RXD0 (hps_0_hps_io_hps_io_emac1_inst_RXD0),
	.hps_0_hps_io_hps_io_emac1_inst_MDIO (hps_0_hps_io_hps_io_emac1_inst_MDIO),
	.hps_0_hps_io_hps_io_emac1_inst_MDC (hps_0_hps_io_hps_io_emac1_inst_MDC),
	.hps_0_hps_io_hps_io_emac1_inst_RX_CTL (hps_0_hps_io_hps_io_emac1_inst_RX_CTL),
	.hps_0_hps_io_hps_io_emac1_inst_TX_CTL (hps_0_hps_io_hps_io_emac1_inst_TX_CTL),
	.hps_0_hps_io_hps_io_emac1_inst_RX_CLK (hps_0_hps_io_hps_io_emac1_inst_RX_CLK),
	.hps_0_hps_io_hps_io_emac1_inst_RXD1 (hps_0_hps_io_hps_io_emac1_inst_RXD1),
	.hps_0_hps_io_hps_io_emac1_inst_RXD2 (hps_0_hps_io_hps_io_emac1_inst_RXD2),
	.hps_0_hps_io_hps_io_emac1_inst_RXD3 (hps_0_hps_io_hps_io_emac1_inst_RXD3),
	.hps_0_hps_io_hps_io_qspi_inst_IO0 (hps_0_hps_io_hps_io_qspi_inst_IO0),
	.hps_0_hps_io_hps_io_qspi_inst_IO1 (hps_0_hps_io_hps_io_qspi_inst_IO1),
	.hps_0_hps_io_hps_io_qspi_inst_IO2 (hps_0_hps_io_hps_io_qspi_inst_IO2),
	.hps_0_hps_io_hps_io_qspi_inst_IO3 (hps_0_hps_io_hps_io_qspi_inst_IO3),
	.hps_0_hps_io_hps_io_qspi_inst_SS0 (hps_0_hps_io_hps_io_qspi_inst_SS0),
	.hps_0_hps_io_hps_io_qspi_inst_CLK (hps_0_hps_io_hps_io_qspi_inst_CLK),
	.hps_0_hps_io_hps_io_sdio_inst_CMD (hps_0_hps_io_hps_io_sdio_inst_CMD),
	.hps_0_hps_io_hps_io_sdio_inst_D0 (hps_0_hps_io_hps_io_sdio_inst_D0),
	.hps_0_hps_io_hps_io_sdio_inst_D1 (hps_0_hps_io_hps_io_sdio_inst_D1),
	.hps_0_hps_io_hps_io_sdio_inst_CLK (hps_0_hps_io_hps_io_sdio_inst_CLK),
	.hps_0_hps_io_hps_io_sdio_inst_D2 (hps_0_hps_io_hps_io_sdio_inst_D2),
	.hps_0_hps_io_hps_io_sdio_inst_D3 (hps_0_hps_io_hps_io_sdio_inst_D3),
	.hps_0_hps_io_hps_io_usb1_inst_D0 (hps_0_hps_io_hps_io_usb1_inst_D0),
	.hps_0_hps_io_hps_io_usb1_inst_D1 (hps_0_hps_io_hps_io_usb1_inst_D1),
	.hps_0_hps_io_hps_io_usb1_inst_D2 (hps_0_hps_io_hps_io_usb1_inst_D2),
	.hps_0_hps_io_hps_io_usb1_inst_D3 (hps_0_hps_io_hps_io_usb1_inst_D3),
	.hps_0_hps_io_hps_io_usb1_inst_D4 (hps_0_hps_io_hps_io_usb1_inst_D4),
	.hps_0_hps_io_hps_io_usb1_inst_D5 (hps_0_hps_io_hps_io_usb1_inst_D5),
	.hps_0_hps_io_hps_io_usb1_inst_D6 (hps_0_hps_io_hps_io_usb1_inst_D6),
	.hps_0_hps_io_hps_io_usb1_inst_D7 (hps_0_hps_io_hps_io_usb1_inst_D7),
	.hps_0_hps_io_hps_io_usb1_inst_CLK (hps_0_hps_io_hps_io_usb1_inst_CLK),
	.hps_0_hps_io_hps_io_usb1_inst_STP (hps_0_hps_io_hps_io_usb1_inst_STP),
	.hps_0_hps_io_hps_io_usb1_inst_DIR (hps_0_hps_io_hps_io_usb1_inst_DIR),
	.hps_0_hps_io_hps_io_usb1_inst_NXT (hps_0_hps_io_hps_io_usb1_inst_NXT),
	.hps_0_hps_io_hps_io_spim0_inst_CLK (hps_0_hps_io_hps_io_spim0_inst_CLK),
	.hps_0_hps_io_hps_io_spim0_inst_MOSI (hps_0_hps_io_hps_io_spim0_inst_MOSI),
	.hps_0_hps_io_hps_io_spim0_inst_MISO (hps_0_hps_io_hps_io_spim0_inst_MISO),
	.hps_0_hps_io_hps_io_spim0_inst_SS0 (hps_0_hps_io_hps_io_spim0_inst_SS0),
	.hps_0_hps_io_hps_io_spim1_inst_CLK (hps_0_hps_io_hps_io_spim1_inst_CLK),
	.hps_0_hps_io_hps_io_spim1_inst_MOSI (hps_0_hps_io_hps_io_spim1_inst_MOSI),
	.hps_0_hps_io_hps_io_spim1_inst_MISO (hps_0_hps_io_hps_io_spim1_inst_MISO),
	.hps_0_hps_io_hps_io_spim1_inst_SS0 (hps_0_hps_io_hps_io_spim1_inst_SS0),
	.hps_0_hps_io_hps_io_uart0_inst_RX (hps_0_hps_io_hps_io_uart0_inst_RX),
	.hps_0_hps_io_hps_io_uart0_inst_TX (hps_0_hps_io_hps_io_uart0_inst_TX),
	.hps_0_hps_io_hps_io_i2c1_inst_SDA (hps_0_hps_io_hps_io_i2c1_inst_SDA),
	.hps_0_hps_io_hps_io_i2c1_inst_SCL (hps_0_hps_io_hps_io_i2c1_inst_SCL),
	.hps_0_hps_io_hps_io_gpio_inst_GPIO00 (hps_0_hps_io_hps_io_gpio_inst_GPIO00),
	.hps_0_hps_io_hps_io_gpio_inst_GPIO09 (hps_0_hps_io_hps_io_gpio_inst_GPIO09),
	.hps_0_hps_io_hps_io_gpio_inst_GPIO35 (hps_0_hps_io_hps_io_gpio_inst_GPIO35),
	.hps_0_hps_io_hps_io_gpio_inst_GPIO48 (hps_0_hps_io_hps_io_gpio_inst_GPIO48),
	.hps_0_hps_io_hps_io_gpio_inst_GPIO53 (hps_0_hps_io_hps_io_gpio_inst_GPIO53),
	.hps_0_hps_io_hps_io_gpio_inst_GPIO54 (hps_0_hps_io_hps_io_gpio_inst_GPIO54),
	.hps_0_hps_io_hps_io_gpio_inst_GPIO55 (hps_0_hps_io_hps_io_gpio_inst_GPIO55),
	.hps_0_hps_io_hps_io_gpio_inst_GPIO56 (hps_0_hps_io_hps_io_gpio_inst_GPIO56),
	.hps_0_hps_io_hps_io_gpio_inst_GPIO61 (hps_0_hps_io_hps_io_gpio_inst_GPIO61),
	.hps_0_hps_io_hps_io_gpio_inst_GPIO62 (hps_0_hps_io_hps_io_gpio_inst_GPIO62),
	.hps_0_h2f_reset_reset_n (hps_0_h2f_reset_reset_n),
	.xillyvga_0_conduit_vga_clk_in ( clk_bot1 ),
	.xillyvga_0_conduit_vga_vga_hsync ( vga_hsync_w ),
	.xillyvga_0_conduit_vga_vga_vsync ( vga_vsync_w ),
	.xillyvga_0_conduit_vga_vga_de ( ), // For use with DVI
	.xillyvga_0_conduit_vga_vga_red ( vga_red_w ),
	.xillyvga_0_conduit_vga_vga_green ( vga_green_w ),
	.xillyvga_0_conduit_vga_vga_blue ( vga_blue_w ),
	.xillyvga_0_conduit_vga_vga_clk(vga_clk),
	.xillybus_0_conduit_bus_clk (bus_clk),
	.xillybus_0_conduit_bus_rst_n (bus_rst_n),
	.xillybus_0_conduit_host_interrupt (host_interrupt),
	.xillybus_0_conduit_S_AXI_AWVALID (S_AXI_AWVALID),
	.xillybus_0_conduit_S_AXI_WDATA (S_AXI_WDATA),
	.xillybus_0_conduit_S_AXI_WSTRB (S_AXI_WSTRB),
	.xillybus_0_conduit_S_AXI_WVALID (S_AXI_WVALID),
	.xillybus_0_conduit_S_AXI_BREADY (S_AXI_BREADY),
	.xillybus_0_conduit_S_AXI_ARADDR (S_AXI_ARADDR),
	.xillybus_0_conduit_S_AXI_ARVALID (S_AXI_ARVALID),
	.xillybus_0_conduit_S_AXI_RREADY (S_AXI_RREADY),
	.xillybus_0_conduit_S_AXI_ARREADY (S_AXI_ARREADY),
	.xillybus_0_conduit_S_AXI_RDATA (S_AXI_RDATA),
	.xillybus_0_conduit_S_AXI_RRESP (S_AXI_RRESP),
	.xillybus_0_conduit_S_AXI_RVALID (S_AXI_RVALID),
	.xillybus_0_conduit_S_AXI_WREADY (S_AXI_WREADY),
	.xillybus_0_conduit_S_AXI_BRESP (S_AXI_BRESP),
	.xillybus_0_conduit_S_AXI_BVALID (S_AXI_BVALID),
	.xillybus_0_conduit_S_AXI_AWREADY (S_AXI_AWREADY),
	.xillybus_0_conduit_M_AXI_ARREADY (M_AXI_ACP_ARREADY),
	.xillybus_0_conduit_M_AXI_ARVALID (M_AXI_ACP_ARVALID),
	.xillybus_0_conduit_M_AXI_ARADDR (M_AXI_ACP_ARADDR),
	.xillybus_0_conduit_M_AXI_ARLEN (M_AXI_ACP_ARLEN),
	.xillybus_0_conduit_M_AXI_ARSIZE (M_AXI_ACP_ARSIZE),
	.xillybus_0_conduit_M_AXI_ARBURST (M_AXI_ACP_ARBURST),
	.xillybus_0_conduit_M_AXI_ARPROT (M_AXI_ACP_ARPROT),
	.xillybus_0_conduit_M_AXI_ARCACHE (M_AXI_ACP_ARCACHE),
	.xillybus_0_conduit_M_AXI_RREADY (M_AXI_ACP_RREADY),
	.xillybus_0_conduit_M_AXI_RVALID (M_AXI_ACP_RVALID),
	.xillybus_0_conduit_M_AXI_RDATA (M_AXI_ACP_RDATA),
	.xillybus_0_conduit_M_AXI_RRESP (M_AXI_ACP_RRESP),
	.xillybus_0_conduit_M_AXI_RLAST (M_AXI_ACP_RLAST),
	.xillybus_0_conduit_M_AXI_AWREADY (M_AXI_ACP_AWREADY),
	.xillybus_0_conduit_M_AXI_AWVALID (M_AXI_ACP_AWVALID),
	.xillybus_0_conduit_M_AXI_AWADDR (M_AXI_ACP_AWADDR),
	.xillybus_0_conduit_M_AXI_AWLEN (M_AXI_ACP_AWLEN),
	.xillybus_0_conduit_M_AXI_AWSIZE (M_AXI_ACP_AWSIZE),
	.xillybus_0_conduit_M_AXI_AWBURST (M_AXI_ACP_AWBURST),
	.xillybus_0_conduit_M_AXI_AWPROT (M_AXI_ACP_AWPROT),
	.xillybus_0_conduit_M_AXI_AWCACHE (M_AXI_ACP_AWCACHE),
	.xillybus_0_conduit_M_AXI_WREADY (M_AXI_ACP_WREADY),
	.xillybus_0_conduit_M_AXI_WVALID (M_AXI_ACP_WVALID),
	.xillybus_0_conduit_M_AXI_WDATA (M_AXI_ACP_WDATA),
	.xillybus_0_conduit_M_AXI_WID (M_AXI_ACP_WID),
	.xillybus_0_conduit_M_AXI_WSTRB (M_AXI_ACP_WSTRB),
	.xillybus_0_conduit_M_AXI_WLAST (M_AXI_ACP_WLAST),
	.xillybus_0_conduit_M_AXI_BREADY (M_AXI_ACP_BREADY),
	.xillybus_0_conduit_M_AXI_BVALID (M_AXI_ACP_BVALID),
	.xillybus_0_conduit_M_AXI_BRESP (M_AXI_ACP_BRESP),
	.xillybus_0_conduit_M_AXI_AWLOCK (M_AXI_ACP_AWLOCK),
	.xillybus_0_conduit_M_AXI_ARLOCK (M_AXI_ACP_ARLOCK),
	.xillybus_0_conduit_M_AXI_AWID (M_AXI_ACP_AWID),
	.xillybus_0_conduit_M_AXI_BID (M_AXI_ACP_BID),
	.xillybus_0_conduit_M_AXI_RID (M_AXI_ACP_RID),
	.xillybus_0_conduit_M_AXI_ARID (M_AXI_ACP_ARID),
	.xillybus_0_conduit_M_AXI_ARUSER (M_AXI_ACP_ARUSER),
	.xillybus_0_conduit_M_AXI_AWUSER (M_AXI_ACP_AWUSER),
	.xillybus_0_conduit_S_AXI_AWID (S_AXI_AWID),
	.xillybus_0_conduit_S_AXI_AWADDR (S_AXI_AWADDR),
	.xillybus_0_conduit_S_AXI_AWLEN (S_AXI_AWLEN),
	.xillybus_0_conduit_S_AXI_AWSIZE (S_AXI_AWSIZE),
	.xillybus_0_conduit_S_AXI_AWBURST (S_AXI_AWBURST),
	.xillybus_0_conduit_S_AXI_AWLOCK (S_AXI_AWLOCK),
	.xillybus_0_conduit_S_AXI_AWCACHE (S_AXI_AWCACHE),
	.xillybus_0_conduit_S_AXI_AWPROT (S_AXI_AWPROT),
	.xillybus_0_conduit_S_AXI_AWUSER (S_AXI_AWUSER),
	.xillybus_0_conduit_S_AXI_WID (S_AXI_WID),
	.xillybus_0_conduit_S_AXI_BID (S_AXI_BID),
	.xillybus_0_conduit_S_AXI_WLAST (S_AXI_WLAST),
	.xillybus_0_conduit_S_AXI_ARID (S_AXI_ARID),
	.xillybus_0_conduit_S_AXI_ARLEN (S_AXI_ARLEN),
	.xillybus_0_conduit_S_AXI_ARSIZE (S_AXI_ARSIZE),
	.xillybus_0_conduit_S_AXI_ARBURST (S_AXI_ARBURST),
	.xillybus_0_conduit_S_AXI_ARLOCK (S_AXI_ARLOCK),
	.xillybus_0_conduit_S_AXI_ARCACHE (S_AXI_ARCACHE),
	.xillybus_0_conduit_S_AXI_ARPROT (S_AXI_ARPROT),
	.xillybus_0_conduit_S_AXI_ARUSER (S_AXI_ARUSER),
	.xillybus_0_conduit_S_AXI_RID (S_AXI_RID),
	.xillybus_0_conduit_S_AXI_RLAST (S_AXI_RLAST),	
	.xillybus_lite_0_conduit_lite_clk ( user_clk ),
	.xillybus_lite_0_conduit_lite_wren ( user_wren ),
	.xillybus_lite_0_conduit_lite_wstrb ( user_wstrb ),
	.xillybus_lite_0_conduit_lite_rden ( user_rden ),
	.xillybus_lite_0_conduit_lite_rd_data ( user_rd_data ),
	.xillybus_lite_0_conduit_lite_wr_data ( user_wr_data ),
	.xillybus_lite_0_conduit_lite_addr ( user_addr ),
	.xillybus_lite_0_conduit_lite_irq ( user_irq )
	);

   altera_pll #(
		.fractional_vco_multiplier("false"),
		.reference_clock_frequency("50.0 MHz"),
		.operation_mode("normal"),
		.number_of_clocks(1),
		.output_clock_frequency0("100.0 MHz"),
		.phase_shift0("0 ps"),
		.duty_cycle0(50),
		.output_clock_frequency1("0 MHz"),
		.phase_shift1("0 ps"),
		.duty_cycle1(50),
		.output_clock_frequency2("0 MHz"),
		.phase_shift2("0 ps"),
		.duty_cycle2(50),
		.output_clock_frequency3("0 MHz"),
		.phase_shift3("0 ps"),
		.duty_cycle3(50),
		.output_clock_frequency4("0 MHz"),
		.phase_shift4("0 ps"),
		.duty_cycle4(50),
		.output_clock_frequency5("0 MHz"),
		.phase_shift5("0 ps"),
		.duty_cycle5(50),
		.output_clock_frequency6("0 MHz"),
		.phase_shift6("0 ps"),
		.duty_cycle6(50),
		.output_clock_frequency7("0 MHz"),
		.phase_shift7("0 ps"),
		.duty_cycle7(50),
		.output_clock_frequency8("0 MHz"),
		.phase_shift8("0 ps"),
		.duty_cycle8(50),
		.output_clock_frequency9("0 MHz"),
		.phase_shift9("0 ps"),
		.duty_cycle9(50),
		.output_clock_frequency10("0 MHz"),
		.phase_shift10("0 ps"),
		.duty_cycle10(50),
		.output_clock_frequency11("0 MHz"),
		.phase_shift11("0 ps"),
		.duty_cycle11(50),
		.output_clock_frequency12("0 MHz"),
		.phase_shift12("0 ps"),
		.duty_cycle12(50),
		.output_clock_frequency13("0 MHz"),
		.phase_shift13("0 ps"),
		.duty_cycle13(50),
		.output_clock_frequency14("0 MHz"),
		.phase_shift14("0 ps"),
		.duty_cycle14(50),
		.output_clock_frequency15("0 MHz"),
		.phase_shift15("0 ps"),
		.duty_cycle15(50),
		.output_clock_frequency16("0 MHz"),
		.phase_shift16("0 ps"),
		.duty_cycle16(50),
		.output_clock_frequency17("0 MHz"),
		.phase_shift17("0 ps"),
		.duty_cycle17(50),
		.pll_type("General"),
		.pll_subtype("General")
		) bus_pll
     (      
      .outclk	(clk_clk),
      .locked	(locked),
      .fboutclk	( ),
      .fbclk	(1'b0),
      .rst	(1'b0),
      .refclk	(clk_bot1)
      );

   assign vga_blank_n = 1; // Blanking is done with data values
   assign vga_sync_n = 0; // Asserted, otherwise bias on green analog signal

   altddio_out vga_pads
     (
      .datain_h ({ vga_red_w, vga_green_w, vga_blue_w,
		   vga_hsync_w, vga_vsync_w, 1'b0 }),
      .datain_l ({ vga_red_w, vga_green_w, vga_blue_w,
		   vga_hsync_w, vga_vsync_w, 1'b1 }),
      .outclock (vga_clk),
      .dataout ({ vga_red, vga_green, vga_blue,
		  vga_hsync, vga_vsync, vga_clk_out }),
      .aclr (1'b0),
      .aset (1'b0),
      .oe (1'b1),
      .oe_out (),
      .outclocken (1'b1),
      .sclr (1'b0),
      .sset (1'b0));
   defparam
     vga_pads.extend_oe_disable = "OFF",
     vga_pads.intended_device_family = "Cyclone V",
     vga_pads.invert_output = "OFF",
     vga_pads.lpm_hint = "UNUSED",
     vga_pads.lpm_type = "altddio_out",
     vga_pads.oe_reg = "UNREGISTERED",
     vga_pads.power_up_high = "OFF",
     vga_pads.width = 27;

  xillybus_core  xillybus_core_ins(.M_AXI_ACP_ARREADY_w(M_AXI_ACP_ARREADY),
    .M_AXI_ACP_ARVALID_w(M_AXI_ACP_ARVALID), .user_mem_8_addr_w(user_mem_8_addr),
    .user_mem_8_addr_update_w(user_mem_8_addr_update),
    .M_AXI_ACP_ARADDR_w(M_AXI_ACP_ARADDR), .M_AXI_ACP_ARLEN_w(M_AXI_ACP_ARLEN),
    .M_AXI_ACP_ARSIZE_w(M_AXI_ACP_ARSIZE), .M_AXI_ACP_ARBURST_w(M_AXI_ACP_ARBURST),
    .M_AXI_ACP_ARPROT_w(M_AXI_ACP_ARPROT), .M_AXI_ACP_ARCACHE_w(M_AXI_ACP_ARCACHE),
    .M_AXI_ACP_RREADY_w(M_AXI_ACP_RREADY), .M_AXI_ACP_RVALID_w(M_AXI_ACP_RVALID),
    .M_AXI_ACP_RDATA_w(M_AXI_ACP_RDATA), .M_AXI_ACP_RRESP_w(M_AXI_ACP_RRESP),
    .M_AXI_ACP_RLAST_w(M_AXI_ACP_RLAST), .M_AXI_ACP_AWREADY_w(M_AXI_ACP_AWREADY),
    .M_AXI_ACP_AWVALID_w(M_AXI_ACP_AWVALID), .M_AXI_ACP_AWADDR_w(M_AXI_ACP_AWADDR),
    .M_AXI_ACP_AWLEN_w(M_AXI_ACP_AWLEN), .M_AXI_ACP_AWSIZE_w(M_AXI_ACP_AWSIZE),
    .M_AXI_ACP_AWBURST_w(M_AXI_ACP_AWBURST), .M_AXI_ACP_AWPROT_w(M_AXI_ACP_AWPROT),
    .M_AXI_ACP_AWCACHE_w(M_AXI_ACP_AWCACHE), .M_AXI_ACP_WREADY_w(M_AXI_ACP_WREADY),
    .M_AXI_ACP_WVALID_w(M_AXI_ACP_WVALID), .M_AXI_ACP_WDATA_w(M_AXI_ACP_WDATA),
    .M_AXI_ACP_WID_w(M_AXI_ACP_WID), .M_AXI_ACP_WSTRB_w(M_AXI_ACP_WSTRB),
    .M_AXI_ACP_WLAST_w(M_AXI_ACP_WLAST), .M_AXI_ACP_BREADY_w(M_AXI_ACP_BREADY),
    .M_AXI_ACP_BVALID_w(M_AXI_ACP_BVALID), .M_AXI_ACP_BRESP_w(M_AXI_ACP_BRESP),
    .M_AXI_ACP_AWLOCK_w(M_AXI_ACP_AWLOCK), .M_AXI_ACP_ARLOCK_w(M_AXI_ACP_ARLOCK),
    .M_AXI_ACP_AWID_w(M_AXI_ACP_AWID), .M_AXI_ACP_BID_w(M_AXI_ACP_BID),
    .M_AXI_ACP_RID_w(M_AXI_ACP_RID), .M_AXI_ACP_ARID_w(M_AXI_ACP_ARID),
    .M_AXI_ACP_ARUSER_w(M_AXI_ACP_ARUSER), .M_AXI_ACP_AWUSER_w(M_AXI_ACP_AWUSER),
    .S_AXI_AWID_w(S_AXI_AWID), .S_AXI_AWADDR_w(S_AXI_AWADDR),
    .S_AXI_AWLEN_w(S_AXI_AWLEN), .S_AXI_AWSIZE_w(S_AXI_AWSIZE),
    .S_AXI_AWBURST_w(S_AXI_AWBURST), .S_AXI_AWLOCK_w(S_AXI_AWLOCK),
    .S_AXI_AWCACHE_w(S_AXI_AWCACHE), .S_AXI_AWPROT_w(S_AXI_AWPROT),
    .S_AXI_AWUSER_w(S_AXI_AWUSER), .S_AXI_WID_w(S_AXI_WID),
    .S_AXI_BID_w(S_AXI_BID), .S_AXI_WLAST_w(S_AXI_WLAST),
    .S_AXI_ARID_w(S_AXI_ARID), .S_AXI_ARLEN_w(S_AXI_ARLEN),
    .S_AXI_ARSIZE_w(S_AXI_ARSIZE), .S_AXI_ARBURST_w(S_AXI_ARBURST),
    .S_AXI_ARLOCK_w(S_AXI_ARLOCK), .S_AXI_ARCACHE_w(S_AXI_ARCACHE),
    .S_AXI_ARPROT_w(S_AXI_ARPROT), .S_AXI_ARUSER_w(S_AXI_ARUSER),
    .S_AXI_RID_w(S_AXI_RID), .S_AXI_RLAST_w(S_AXI_RLAST),
    .GPIO_LED_w(GPIO_LED), .quiesce_w(quiesce), .user_r_read_32_rden_w(user_r_read_32_rden),
    .user_r_read_32_data_w(user_r_read_32_data), .user_r_read_32_empty_w(user_r_read_32_empty),
    .user_r_read_32_eof_w(user_r_read_32_eof), .user_r_read_32_open_w(user_r_read_32_open),
    .user_w_write_32_wren_w(user_w_write_32_wren),
    .user_w_write_32_data_w(user_w_write_32_data),
    .user_w_write_32_full_w(user_w_write_32_full),
    .user_w_write_32_open_w(user_w_write_32_open),
    .user_r_read_8_rden_w(user_r_read_8_rden), .user_r_read_8_data_w(user_r_read_8_data),
    .user_r_read_8_empty_w(user_r_read_8_empty), .user_r_read_8_eof_w(user_r_read_8_eof),
    .user_r_read_8_open_w(user_r_read_8_open), .bus_clk_w(bus_clk),
    .bus_rst_n_w(bus_rst_n), .host_interrupt_w(host_interrupt),
    .S_AXI_AWVALID_w(S_AXI_AWVALID), .S_AXI_WDATA_w(S_AXI_WDATA),
    .user_w_write_8_wren_w(user_w_write_8_wren), .user_w_write_8_data_w(user_w_write_8_data),
    .user_w_write_8_full_w(user_w_write_8_full), .user_w_write_8_open_w(user_w_write_8_open),
    .S_AXI_WSTRB_w(S_AXI_WSTRB), .S_AXI_WVALID_w(S_AXI_WVALID),
    .S_AXI_BREADY_w(S_AXI_BREADY), .S_AXI_ARADDR_w(S_AXI_ARADDR),
    .S_AXI_ARVALID_w(S_AXI_ARVALID), .user_r_mem_8_rden_w(user_r_mem_8_rden),
    .user_r_mem_8_data_w(user_r_mem_8_data), .user_r_mem_8_empty_w(user_r_mem_8_empty),
    .user_r_mem_8_eof_w(user_r_mem_8_eof), .user_r_mem_8_open_w(user_r_mem_8_open),
    .S_AXI_RREADY_w(S_AXI_RREADY), .S_AXI_ARREADY_w(S_AXI_ARREADY),
    .S_AXI_RDATA_w(S_AXI_RDATA), .S_AXI_RRESP_w(S_AXI_RRESP),
    .S_AXI_RVALID_w(S_AXI_RVALID), .S_AXI_WREADY_w(S_AXI_WREADY),
    .user_w_mem_8_wren_w(user_w_mem_8_wren), .user_w_mem_8_data_w(user_w_mem_8_data),
    .user_w_mem_8_full_w(user_w_mem_8_full), .user_w_mem_8_open_w(user_w_mem_8_open),
    .S_AXI_BRESP_w(S_AXI_BRESP), .S_AXI_BVALID_w(S_AXI_BVALID),
    .S_AXI_AWREADY_w(S_AXI_AWREADY));

endmodule
